#include "BgSubstitution.h"

BgSubstitution::BgSubstitution( IplImage * bg0 ) {
	bg = cvCreateImage( cvSize( bg0->width, bg0->height ), IPL_DEPTH_8U, 3 );
	bg->origin = bg0->origin;
	cvCopy( bg0, bg );
	
	luvBg = cvCreateImage( cvSize( bg0->width, bg0->height ), IPL_DEPTH_8U, 3 );
	luvBg->origin = bg0->origin;
	cvCvtColor( bg, luvBg, CV_RGB2Luv );
	
}

BgSubstitution::~BgSubstitution( ) {
	if( bg ) cvReleaseImage( &bg );
	if( luvBg ) cvReleaseImage( &luvBg );
}


void BgSubstitution::substitute( IplImage * frame ) {
		int offset;
	int l1, u1, v1, l2, u2, v2;
	int ld, ud, vd;
	float dist;
	unsigned char * p1, *p2;
	
	luv = frame;

	
	for( int i = 0; i < frame->height; i++ ) {
		p1 = (unsigned char*)(&luv->imageData[i*luv->widthStep]);
		p2 = (unsigned char*)(&luvBg->imageData[i*luv->widthStep]);
		for( int j = 0; j < frame->width; j++ ) {
	                  offset = (i*luv->widthStep) + 3*j;
			  

/*	                  l1 = *p1++;
	                  u1 = *p1++;
	                  v1 = *p1++;
	                  l2 = *p2++;
	                  u2 = *p2++;
	                  v2 = *p2++;		

	                  ld = l1 - l2;
	                  ud = u1 - u2;
	                  vd = v1 - v2;*/
			p1++, p2++;
			ud = (int)*p1++ - (int)*p2++;
			vd = (int)*p1++ - (int)*p2++;
					  
	                   
			   
			if( sqrt( ud*ud + vd*vd) < 10 ) {
	                         frame->imageData[ offset + 0 ] =
	                         frame->imageData[ offset + 1 ] =
	                         frame->imageData[ offset + 2 ] = 0;
			}
		}
	}

}

