
#include "VideoSource.h"


VideoSource::VideoSource( const int webcamID ) {
        capture = cvCaptureFromCAM( webcamID );
	
	init( );
}

VideoSource::VideoSource( const char * aviFileName ) {
        capture = cvCaptureFromAVI( aviFileName );
	
	init( );
}

VideoSource::~VideoSource( ) {
	destroy( );
}

void VideoSource::init( void ) {
	frame =  0;
}

void VideoSource::destroy( void ) {
	if( frame )
		cvReleaseImage( &frame );
}


		
IplImage * VideoSource::getFrame( void ) {
	IplImage * frame0 = cvQueryFrame( capture );
	 
	if ( !frame ) {
		frame = cvCreateImage( cvSize( frame0->width, frame0->height ), IPL_DEPTH_8U, 3 );
		frame->origin = frame0->origin;
	}
		
	 
	cvSmooth( frame0, frame, CV_GAUSSIAN, 5, 0, 0 );
	 
	return frame;
}

